<template>

    <v-card max-width="600" :elevation="11" class="pa-6">
        <v-card-text>
            <v-alert v-if="err != ''" dense text type="error">
                {{err}}
            </v-alert>
            <v-alert v-if="ok != ''" dense text type="success">
                {{success}}
            </v-alert>
            <p class="display-1 text--primary">
                Create Floor
            </p>

            <v-form ref='form' v-model="valid">
                <v-text-field label="Floor Name"
                              name="Floor Name"
                              :counter="16"
                              :rules="nameRules"
                              v-model="name"
                              :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.floor' :''"
                              :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.floor' : ''"
                              required
                              type="text"/>
                <v-select
                        :items="timeZones"

                        v-model="tz"
                        :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.time' :''"
                        :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.time' : ''"
                        :rules="tzRule"
                        required
                        label="TimeZone"
                />

            </v-form>
        </v-card-text>

        <v-card-actions>
            <v-spacer/>
            <v-btn color="primary"
                   @click="Clear">
                Close
            </v-btn>
            <v-btn color="primary"
                   :disabled="!valid"
                   @click="Create">
                Create
            </v-btn>
        </v-card-actions>
    </v-card>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component, Prop} from 'vue-property-decorator';
    import {Validable} from "../../mixins/Validable";
    import {Mixins} from "vue-mixin-decorator";
    import {coreApi} from "../../init";
    import {FloorResponse} from "../../../../classLibrary/core/floorResponse";


    @Component
    export default class CreateFloor extends Mixins<Validable>(Validable) {
        valid: boolean = true;
        name: string = "";
        timeZones: string[] = [];
        tz: string = "";

        @Prop() closeF!: () => void;
        @Prop() createF!: () => void;

        nameRules = [
            (v: any) => !!v || 'Floor Name is required',
            (v: any) => (v && v.length >= 5) || 'Floor Name must be at least 5 characters long',
            (v: any) => (v && v.length <= 16) || 'Floor Name cannot exceed 16 characters long',
        ]
        tzRule = [
            (v: any) => !!v || 'Time Zone is Required'
        ]


        async created() {
            const tzr = await coreApi.Get<string[]>("timezones");
            if (tzr.success) {
                this.timeZones = tzr.Ok!;
            } else {
                this.err = tzr.error!;
            }
        }

        get Form(): any {
            return this.$refs['form'];
        }

        async Create() {
            const valid = this.Form.validate();
            if (valid) {
                const r = await coreApi.Post<FloorResponse>("Floor", {
                    name: this.name,
                    timeZone: this.tz
                });
                if (r.success) {
                    this.ok = `Create floor ${r.Ok!.info.name}`;
                    this.createF();
                } else {
                    this.err = r.error!;
                }
            } else {
                this.err = "";
            }
        }

        Clear() {
            this.closeF();
        }

    }
</script>
